/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.wahl;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.wahl.boundary.AbstractWahlterminSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlterminChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminConversationStore;
import de.ivu.elect.business.wahl.boundary.WahlterminExtendedDAO;
import de.ivu.elect.business.wahl.boundary.WahlterminSearch;
import de.ivu.elect.business.wahl.boundary.WahlterminSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.wahl.entity.Wahltermin;
import de.ivu.elect.business.wahl.entity.WahlterminMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractWahlterminSearchView.COMPONENT_NAME)
@View(viewId = AbstractWahlterminSearchView.VIEW_ID, useCase = UseCasePermission.WAHLTERMIN_SEARCH)
public abstract class AbstractWahlterminSearchView extends AbstractElectSearchView<Wahltermin> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlterminSearchView";
  
  public static final String VIEW_ID = "/wahl/wahltermin-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractWahlterminSearchView requestHandler;

  @Inject
  private transient WahlterminExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(WahlterminConversationStore.class)
  protected transient WahlterminConversationStore conversationStore;

  @Inject
  protected transient WahlterminSearch search;

  @Inject
  @ConversationGroup(AbstractWahlterminSearchParameters.class)
  protected transient WahlterminSearchParameters searchParameters;

  @Inject
  protected transient WahlterminMeta entityMeta;

  public AbstractWahlterminSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Wahltermin getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Wahltermin entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public WahlterminSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Wahltermin> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Wahltermin> create();
  }

  @Override
  public List<Wahltermin> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Wahltermin> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onWahlterminChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractWahlterminSearchView {

    @View
    @Inject
    private transient Instance<AbstractWahlterminSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractWahlterminSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
